if not LibStub then return end
local function round(num, places)
	return tonumber(string.format("%."..(places or 0).."f",num))
end
local gsloaded = IsAddOnLoaded("GearScore")
local slots = {BackSlot=true, ChestSlot=true, FeetSlot=true, Finger0Slot=true, Finger1Slot=true, HandsSlot=true, HeadSlot=true, LegsSlot=true, MainHandSlot=true, NeckSlot=true, RangedSlot=true, SecondaryHandSlot=true, Trinket0Slot=true, Trinket1Slot=true, WaistSlot=true, WristSlot=true}
local numeric = {}
for slot in pairs(slots) do
	numeric[GetInventorySlotInfo(slot)] = slot
end
local LibNameplate = LibStub("LibNameplate-1.0")
if not EPEEN then EPEEN = CreateFrame("Frame") end
local addon = EPEEN or CreateFrame("Frame")
addon.plates = {}
function addon:UpdatePeen(name, plate)
	if not plate.epeen then return end
	if not self.db.max then return end
	local peen = plate.epeen
	if gsloaded and GS_Data[GetRealmName()].Players[name] then
		local avg = GS_Data[GetRealmName()].Players[name].Average
		if avg > self.db.max then
			self.db.max = avg
			self:UpdateAllPeens()
		end
		local pavg = GS_Data[GetRealmName()].Players[UnitName("player")] and GS_DATA[GetRealmName()].Players[UnitName("player")].Average or self.db[UnitName("player")] and self.db[UnitName("player")].avg
		peen.num:SetText(avg)
		peen.type:SetText(pavg and (avg > pavg and "N\nO\nL\nI\nF\nE" or avg < pavg and "N\n0\n0\nB"))
		peen.tex:Show()
		peen.num:Show()
		peen.type:Show()
		peen.tex2:SetAlpha(1)
	elseif self.db[name] then
		peen:SetHeight((self.db[name].avg/self.db.max)*150+35)
		local avg = self.db[name].avg
		local pavg = self.db[UnitName("player")] and self.db[UnitName("player")].avg
		peen.num:SetText(avg)
		peen.type:SetText(pavg and (avg > pavg and "N\nO\nL\nI\nF\nE" or avg < pavg and "N\n0\n0\nB"))
		peen.tex:Show()
		peen.num:Show()
		peen.type:Show()
		peen.tex2:SetAlpha(1)
	else
		peen:SetHeight(35)
		peen.tex:Hide()
		peen.num:Hide()
		peen.type:Hide()
		peen.tex2:SetAlpha(0.4)
	end
end
function addon:UpdateAllPeens()
	for num, peen in pairs(addon.plates) do
		if peen:IsVisible() then
			local name = LibNameplate:GetName(peen.plate)
			if name then
				self:UpdatePeen(name, peen.plate)
			end
		end
	end
end
function addon:LibNameplate_NewNameplate(event, namePlate)
	if (LibNameplate:GetType(namePlate) ~= "PLAYER") or (LibNameplate:GetReaction(namePlate) == "HOSTILE") then if namePlate.epeen then namePlate.epeen:Hide() end return end
	local name = LibNameplate:GetName(namePlate)
	if not namePlate.epeen then
		local f = CreateFrame("Frame", nil, namePlate)
		f:SetWidth(35)
		f:SetPoint("BOTTOM", namePlate, "TOP", 0, -5)
		f.tex = f:CreateTexture(nil, "BACKGROUND")
		f.tex:SetPoint("TOPLEFT")
		f.tex:SetTexture(1,1,0)
		f.tex2 = f:CreateTexture(nil, "BACKGROUND")
		f.tex2:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-ROLES")
		f.tex2:SetTexCoord(0.26171875, 0.26171875, 0.26171875, 0.5234375, 0.5234375, 0.26171875, 0.5234375, 0.5234375)
		f.tex2:SetPoint("BOTTOMLEFT")
		f.tex2:SetPoint("TOPRIGHT", f, "BOTTOMRIGHT", 0, 35)
		f.tex:SetPoint("BOTTOMRIGHT", f.tex2, "TOPRIGHT")
		f.num = f:CreateFontString(nil, "ARTWORK")
		f.num:SetPoint("BOTTOM", f, "TOP", 0, 5)
		f.num:SetFont("Fonts\\FRIZQT__.TTF", 15, "OUTLINE")
		f.num:SetTextColor(0.8,0.8,0.8)
		f.type = f:CreateFontString(nil, "ARTWORK")
		f.type:SetPoint("TOP")
		f.type:SetPoint("BOTTOM", 0, 35)
		f.type:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
		f.type:SetTextColor(1,0,0,0.8)
		f.plate = namePlate
		namePlate.epeen = f
		tinsert(addon.plates, f)
	else
		namePlate.epeen:Show()
	end
	self:UpdatePeen(name, namePlate)
end
function addon:LibNameplate_RecycleNameplate(event, namePlate)
	if not namePlate.epeen then return end
	namePlate.epeen:Hide()
end
function addon:DoInspect(unit)
	if (not UnitExists(unit)) or (not CanInspect(unit)) then return end
	local name = UnitName(unit)
	NotifyInspect(unit)
	if not self.db[name] then self.db[name] = {} end
	local d = self.db[name]
	for id in pairs(numeric) do
		local iid = GetInventoryItemID(unit, id)
		if iid then
			local ilvl = (select(4, GetItemInfo(iid)))
			d[id] = ilvl
		end
	end
	local sum, num = 0,0
	for slot, lvl in pairs(d) do
		sum = sum+lvl
		num = num+1
	end
	d.avg = round(sum/num, 0)
	ClearInspectPlayer()
	if d.avg > self.db.max then
		self.db.max = d.avg
		self:UpdateAllPeens()
	else
		local n = LibNameplate:GetNameplateByUnit(unit)
		if n then
			self:UpdatePeen(name, n)
		end
	end
end
LibNameplate.RegisterCallback(addon, "LibNameplate_NewNameplate")
LibNameplate.RegisterCallback(addon, "LibNameplate_RecycleNameplate")
addon:SetScript("OnEvent", function(self, event, ...)
	if not EPEEN_DB	then EPEEN_DB = {} end
	if not EPEEN_DB[GetRealmName()] then EPEEN_DB[GetRealmName()] = {max=0} end
	self.db = EPEEN_DB[GetRealmName()]
	self:UnregisterEvent("ADDON_LOADED")
	self:SetScript("OnEvent", function(self, event, ...)
		if InCombatLockdown() then return end
		if event == "UPDATE_MOUSEOVER_UNIT" then
			self:DoInspect("mouseover")
		elseif event == "PLAYER_FOCUS_CHANGED" then
			self:DoInspect("focus")
		elseif event == "PLAYER_TARGET_CHANGED" then
			self:DoInspect("target")
		elseif event == "UNIT_INVENTORY_CHANGED" then
			self:DoInspect("player")
		end
	end)
	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
	self:RegisterEvent("PLAYER_FOCUS_CHANGED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
end)
addon:RegisterEvent("ADDON_LOADED")